stages:
  - test
  - build
  - deploy

lint:
  stage: test
  image: python:3.7-alpine
  before_script:
   - pip install flake8
  script:
   - flake8

build_master:
  stage: build
  image: docker:stable
  variables:
    DOCKER_DRIVER: overlay2
  before_script:
    - echo "$CI_DOCKER_REGISTRY_TOKEN" | docker login $CI_DOCKER_REGISTRY -u "$CI_DOCKER_REGISTRY_USER" --password-stdin
  script:
    - docker build --cache-from "$CI_REGISTRY_IMAGE" --pull -t "$CI_REGISTRY_IMAGE" ./
    - docker push "$CI_REGISTRY_IMAGE"
  only:
    - main
  environment:
    name: production
    url: https://api.kontakt.amiv.ethz.ch

build_dev:
  stage: build
  image: docker:stable
  variables:
    DOCKER_DRIVER: overlay2
  before_script:
    - echo "$CI_DOCKER_REGISTRY_TOKEN_DEV" | docker login $CI_DOCKER_REGISTRY -u "$CI_DOCKER_REGISTRY_USER_DEV" --password-stdin
  script:
    - docker build --cache-from "$CI_REGISTRY_IMAGE_DEV" --pull -t "$CI_REGISTRY_IMAGE_DEV" ./
    - docker push "$CI_REGISTRY_IMAGE_DEV"
  except:
    - schedules
  environment:
    name: development
    url: https://api.kontakt-dev.amiv.ethz.ch

deploy:
  stage: deploy
  image: amiveth/ansible-ci-helper
  script:
    - python /main.py
